package	jp.co.sds_corp.ratemixer.fx.layout;

import jp.co.sds_corp.transfer.layout.DateConverter;
import jp.co.sds_corp.transfer.layout.FormatParser;
import jp.co.sds_corp.transfer.layout.IConverter;

/**
* フォーマット文字列を解析します。
*/
public class FxFormatParser extends FormatParser
{
	/**
	* 指定されたフォーマット文字列でFormatParserを作成します。
	* @param	fmt		フォーマット文字列
	*/
	public FxFormatParser( String fmt ) {
		super( fmt );
	}

	/**
	* 指定されたコンバータを生成します。
	* @param	c		コンバータを指定する文字
	* @return	コンバータ
	*/
	protected IConverter createConverter( char c ) {
		String opt;
		IConverter conv = null;
		switch ( c ) {
		case 'C':
			opt = getOption();
			conv = new RateConverter( RateConverter.TYPE_CCY1, opt );
			break;
		case 'c':
			opt = getOption();
			conv = new RateConverter( RateConverter.TYPE_CCY2, opt );
			break;
		case 'T':
			opt = getOption();
			conv = new RateConverter( RateConverter.TYPE_TERM, opt );
			break;
		case 'd':
			opt = getOption();
			conv = new DateConverter( DateConverter.TYPE_NOW, opt );
			break;
		case 'D':
			opt = getOption();
			conv = new DateConverter( RateConverter.TYPE_RECV, opt );
			break;
		case 'U':
			opt = getOption();
			conv = new DateConverter( DateConverter.TYPE_UPD, opt );
			break;
		case 'B':
			opt = getOption();
			conv = new RateConverter( RateConverter.TYPE_BID, opt );
			break;
		case 'A':
			opt = getOption();
			conv = new RateConverter( RateConverter.TYPE_ASK, opt );
			break;
		case 'M':
			opt = getOption();
			conv = new RateConverter( RateConverter.TYPE_MID, opt );
			break;
		default:
			break;
		}
		return conv;
	}

}
